import React, { Component } from "react";
import AutoForm from "./AutoForm";
import AutoTable from "./AutoTable";
//import FileForm from "./FileForm";

class ApiAutoView extends Component {
  state = {
    mode : 'insert',
    form_schema : {
      title: "Magasin",
      type: "object",
      required: ["code","nom"],
      properties: {
        code: {type: "string", title: "Code", default: ""},
        nom: {type: "string", title: "Nom", default: ""},
        image: {type: "string",format: "data-url", title: "Image"},
        adresse: {type: "string", title: "Adresse", default: ""},
        type: {type: "string", title: "Type", default: ""}
      }
    },
    UISchema : {},
    table_schema:{ 
      thead:{Name:"Nom",Status:"Status",Notes:"Notes"},
      tbody: [
        {Name:"John",Status:"No Action",Notes:"None",ID:"ID0"},
             {Name:"Jamie",Status:"Requires call",Notes:"None",ID:"ID02"},
             {Name:"Makki",Status:"None",Notes:"None",ID:"ID03"},
             {Name:"Souad",Status:"No Action",Notes:"None",ID:"ID04"},
             {Name:"Bouraoui",Status:"Requires call",Notes:"None",ID:"ID05"},
        ]
    }
  }

  insert = () =>{
    console.log("insert");
  }

  update = () =>{
    console.log("update")
  }

  delete = () =>{
    console.log("delete")
  }

  getFormSchema = () =>{
    console.log('getFormSchema');
    let new_form_schema = {
      title: "Magasin",
      type: "object",
      required: ["code","nom"],
      properties: {
        code: {type: "string", title: "Code", default: "default code"},
        nom: {type: "string", title: "Nom", default: "default nom"},
        image: {type: "string",format: "data-url", title: "Image"},
        adresse: {type: "string", title: "Adresse", default: "default adresse"},
        type: {type: "string", title: "Type", default: "default type"}
      }
    }
    let new_UISchema = { "code": {"ui:readonly": true}}
    this.setState({form_schema : new_form_schema, UISchema : new_UISchema})
  }

  changeMode = () =>{
    this.getFormSchema();
    if (this.state.mode === 'insert') return this.setState({mode:'update'})
    if (this.state.mode === 'update') return this.setState({mode:'insert'})
  }

// Table methods 
  editItem = (ID) =>{
    console.log("EDITE ",ID);
  }

  removeItem = (ID) =>{
      console.log("Remove Element ",ID);
  }

  render() {
    let form_action = this.state.mode === 'insert' ? this.insert : this.update;
    return (
        <div>
          
            <h1>Mode : {this.state.mode} </h1>
            <button onClick={this.changeMode}>Change Mode</button>
            <div className="col-md-6">
            <AutoForm action={form_action} schema={this.state.form_schema} uiSchema={this.state.UISchema}/>
            </div>
            <AutoTable schema={this.state.table_schema} editItem={this.editItem} removeItem={this.removeItem} />
           
            {/*<FileForm /> */}
        </div>
    );
  }
}

export default ApiAutoView;