import React,{Component} from 'react';

class AutoTable extends Component {

    // Generate the header of the table from schema
    generateTableHeader = () => {
        return (
            <tr>
                {Object.values(this.props.schema.thead).map((element,index) => {
                    return <th key={index} >{element}</th>
                })}
                <th></th>
            </tr>
            )
    }

    // Generate the body of the table from schema
    generateTableBody = () => {
        return this.props.schema.tbody.map((object,index) => {
            return (
            <tr key={index}>
                {  Object.keys(this.props.schema.thead).map((element,index) => {
                        return(<td key={index}>{object[element]}</td>)
                })  }
                <td className="last-column">
                    <i onClick={()=>this.props.editItem(object.ID)} className="big grey pencil alternate icon cursor-pointer"></i>
                    <i onClick={()=>this.props.removeItem(object.ID)} className="big red trash alternate icon cursor-pointer"></i>
                </td>
            </tr>
            )
        })
    }
    
    render (){
        return(
                <table className="ui selectable celled table">
                    <thead>
                        {this.generateTableHeader()}
                    </thead>
                    <tbody>
                        {this.generateTableBody()}
                    </tbody>
                </table>
        )
    }
}
export default AutoTable;